SETFSUID(2)

NAME
setfsuid - set user identity used for file system checks

SYNOPSIS
#include <unistd.h> /* glibc uses <sys/fsuid.h> */

int setfsuid(uid_t fsuid);

DESCRIPTION
The system call setfsuid() sets the user ID that the Linux kernel uses to check for all accesses to the file system. Normally, the value of fsuid will shadow the value of the effective user ID. In fact, whenever the effective user ID is changed, fsuid will also be changed to the new value of the effective user ID. Explicit calls to setfsuid() and setfsgid(2) are usually only used by programs such as the Linux NFS server that need to change what user and group ID is used for file access without a corresponding change in the real and effective user and group IDs. A change in the normal user IDs for a program such as the NFS server is a security hole that can expose it to unwanted signals. (But see below.) setfsuid() will only succeed if the caller is the superuser or if fsuid matches either the real user ID, effective user ID, saved set-user-ID, or the current value of fsuid.

RETURN VALUE
On success, the previous value of fsuid is returned. On error, the current value of fsuid is returned.

CONFORMING TO
setfsuid() is Linux specific and should not be used in programs intended to be portable. It is present since Linux 1.1.44 and in libc since libc 4.7.6.

NOTES
When glibc determines that the argument is not a valid user ID, it will return -1 and set errno to EINVAL without attempting the system call.

Note that at the time this system call was introduced, a process could send a signal to a process with the same effective user ID. Today signal permission handling is slightly different.

BUGS
No error messages of any kind are returned to the caller. At the very least, EPERM should be returned when the call fails (because the caller lacks the CAP_SETUID capability).

SEE ALSO
kill(2), setfsgid(2), capabilities(7), credentials(7)